Program Sound;

{ NB: a chunk is 5 contiguous chunkettes of 65535 bytes. }

{$M 8000,327675,328000}
{$I-}
uses dos,crt,tools;
var totpass,chunks,chette:integer;
    chunksize,chettesize,ssize:longint;
    filesp: searchrec;
    speed,device:byte;
    speedkhz:real;
    infile:file;
    filen:string[70];
    bufseg,bufofs,lenhigh,lenlow:word;
    reply:word;
    buff:array [1..5] of pointer;

procedure stop(code:byte);          { stop with error }
begin
 write('Sound Error: ');
 case code of
  1: writeln('Invalid file.');
  4: writeln('Invalid/Out of range parameters.');
  10: writeln('(SOUND.OVL) Load/Init failure.');
  11: writeln('(SOUND.OVL) Internal failure.');
 end;
 halt(1);
end;

procedure initmem;            { load resplay, init mem, open infile }
begin
 for chette:=1 to 5 do
  getmem(buff[chette],65535);
 assign(infile,filen);
 reset(infile,1);
 if ioresult<>0 then stop(1);
 findfirst(filen,anyfile,filesp);
 exec('SOUND.OVL','');
 if doserror<>0 then stop(10);
 asm
  mov ax, 8201h
  int 2fh
  mov reply, ax
 end;
 if reply<>$7746 then stop(10);
 speed:=round(speedkhz*1000/250);
 writeln(#13'File size: ',filesp.size);
 ssize:=filesp.size;
end;

procedure loadbuffer(ind:byte);    { load sample into buff in 64k chunks }
begin
 blockread(infile,buff[ind]^,chettesize,reply);
end;

procedure playsample;        { play sound in buffer }
begin
  writeln(#13'Playing ',chunksize,' bytes...');
  asm
   mov ax, 8210h
   mov cl, 0h
   mov bl, device
   mov bh, speed
   int 2fh
   mov reply, ax
  end;
  if reply<>$1000 then stop(11);
  bufseg:=longint(buff[1]) shr 16;
  bufofs:=longint(buff[1]) and $ffff;
  if bufofs>$8000 then begin
   bufofs:=bufofs-$8000;
   bufseg:=bufseg+$800;
  end;
  lenhigh:=chunksize div 65536;
  lenlow:=chunksize -(lenhigh*65536);
  asm
   mov ax, 8200h
   mov dx, bufseg
   mov di, bufofs
   mov cx, lenhigh
   mov bx, lenlow
   int 2fh
   mov reply, ax
  end;
  if reply<>$1000 then stop(11);
end;

begin
 device:=4;
 textattr:=15;
 clrscr;
 writeln('== Sound player == v1.0  Copyright 1992  H.Beanland');
 writeln('Plays samples from 5-40kHz. Requires 340k free RAM.');
 writeln('Speed is in kHz. SOUND.OVL is part of this program.'#10);
 writeln('Syntax: SOUND file.sam speed [/P]   /P if using parallel port.');
 writeln('ie. SOUND CokeIsIt.SAM 11.5'#10);
 if paramcount<2 then stop(4);
 if paramcount>2 then begin
  filen:=paramstr(3);
  upstr(filen);
  if filen='/P' then device:=0;
 end;
 filen:=paramstr(1);
 val(paramstr(2),speedkhz,reply);
 if (speedkhz<5) or (speedkhz>40) then stop(4);
 initmem;
 chunksize:=65535*5;
 chettesize:=65535;
 totpass:=(ssize div (5*65535))+1;
 writeln('Playing time: ',(ssize/(speedkhz*1000)):0:1,' seconds.');
 write('Requires ',totpass, ' load pass');
 if totpass>1 then writeln('es.')
 else writeln('.');
 if device=0 then writeln('Playing to Parallel port.')
 else writeln('Playing to PC speaker.');
 for chunks:=1 to totpass do begin
  if chunks=totpass then begin
   for chette:=1 to (ssize div 65535) do begin
    loadbuffer(chette);   end;
   if ssize>65535 then chettesize:=ssize-chette*65535
   else begin chettesize:=ssize; chette:=0; end;
   loadbuffer(chette+1);
   chunksize:=ssize;
  end else begin
   for chette:=1 to 5 do
    loadbuffer(chette);
  end;
  playsample;
  ssize:=ssize-5*65535;
 end;
 asm
  mov ax, 8202h
  int 2fh
  mov reply, ax
 end;
 if reply<>$1000 then stop(11);
 writeln(#10'Sample finished OK');
end.
